﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Windows.Threading;
using System.Globalization;

namespace the_matrix
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private DispatcherTimer timerfader = new DispatcherTimer();
        private DispatcherTimer timertextUpdate = new DispatcherTimer();
        private DispatcherTimer timertextremove = new DispatcherTimer();
        private Random rnd = new Random(); 
        public class falling_text_t
        {
            //public string text;
            public int text_length;
            public int max_length;
            public int max_time_alive;
            public int time_alive;
            public double x;
            public double y;
            public List<int> drawingIndices = new List<int>();
            public bool done_updating;
        };

        List<falling_text_t> raintexts;
        List<int> removed_chars = new List<int>();

        public MainWindow()
        {
            InitializeComponent();
            this.WindowState = WindowState.Maximized;
            this.Width = System.Windows.SystemParameters.PrimaryScreenWidth;
            this.Height = System.Windows.SystemParameters.PrimaryScreenHeight;
            this.Opacity = 0;
            raintexts = new List<falling_text_t>();
            timerfader.Interval = new TimeSpan(0, 0, 0, 0, 20);
            timerfader.Tick += timer_Tick;
            timertextUpdate.Interval = new TimeSpan(0, 0, 0, 0, 80);
            timertextUpdate.Tick += timertextUpdate_Tick;
            timerfader.Start();
            timertextremove.Interval = new TimeSpan(0, 0, 0, 0, 250);
            timertextremove.Tick += timertextremove_Tick;

        }
        //-------------------------------------------------------------------------
        private void timer_Tick(object sender, EventArgs e)
        {
            if (this.Opacity < 1)
            {
                this.Opacity += 0.005;
            }
            else
            {
                timertextUpdate.Start();
                timertextremove.Start();
                timerfader.Stop();                
            }
        }
        //--------------------------------------------------------------------------
        private void timertextremove_Tick(object sender, EventArgs e)
        {
            removeCharacters();
            newtext();
        }
        //--------------------------------------------------------------------------
        private void timertextUpdate_Tick(object sender, EventArgs e)
        {                       
            UpdateText();
        }
        //--------------------------------------------------------------------------
        private int Drawtext(char character,Color clr,double x, double y)
        {
            if (removed_chars.Count > 0)
            {
                int index = removed_chars[0];
                removed_chars.RemoveAt(0);
                TextBlock textBlock = ((TextBlock)(cvsDraw.Children[index]));
                textBlock.Text = "" + character;
                textBlock.Opacity = 1;
                textBlock.Foreground = new SolidColorBrush(clr);
                Canvas.SetLeft(textBlock, x);
                Canvas.SetTop(textBlock, y);
                return index;
            }
            else
            {
                TextBlock textBlock = new TextBlock();
                textBlock.Text = "" + character;//+raintexts[i].text[j];
                textBlock.Foreground = new SolidColorBrush(clr);
                textBlock.FontSize = 27;
                textBlock.FontFamily = new FontFamily("MATRIX");// "Arial");
                Canvas.SetLeft(textBlock, x);// raintexts[i].x);
                Canvas.SetTop(textBlock, y);// raintexts[i].y+j*36);
                cvsDraw.Children.Add(textBlock);
                return cvsDraw.Children.Count - 1;
            }
        }
        //--------------------------------------------------------------------------   
        private void newtext()
        {
            falling_text_t t = new falling_text_t();           
            t.x = rnd.Next(0,(int)this.Width+1);
            t.y = rnd.Next(-150, (int)this.Height + 1);
            t.max_length = rnd.Next(3, 26);
            t.max_time_alive = 150;
            t.done_updating = false;
            t.text_length = 0;
            raintexts.Add(t);            
        }
        //--------------------------------------------------------------------------
        private void removeCharacters()
        {
            for (int i = raintexts.Count-1; i >=0 ; i--)
            {                
                if (raintexts[i].done_updating)
                {
                    raintexts[i].time_alive = raintexts[i].time_alive + 1;
                    if (raintexts[i].time_alive > raintexts[i].max_time_alive)
                    {
                        bool dissapeared = false;
                        for (int j = 0; j < raintexts[i].drawingIndices.Count; j++)
                        {
                            cvsDraw.Children[raintexts[i].drawingIndices[j]].Opacity -= 0.02;
                            if ((cvsDraw.Children[raintexts[i].drawingIndices[j]].Opacity <= 0)||(dissapeared))
                            {
                                removed_chars.Add(raintexts[i].drawingIndices[j]);
                                cvsDraw.Children[raintexts[i].drawingIndices[j]].Opacity = 0;
                                dissapeared = true;
                            }                             
                        }
                        if (dissapeared) raintexts.RemoveAt(i);
                    }
                }
            }
        }
        //--------------------------------------------------------------------------
        private void UpdateText()
        {
            for (int i = raintexts.Count - 1; i >= 0; i--)
            {
                if (raintexts[i].text_length < raintexts[i].max_length)
                {
                    char character = (char)(rnd.Next(65, 91));
                    if (rnd.Next(0, 51) > 20)
                    {
                        raintexts[i].text_length++;
                        TextBlock t = getDrawnCharacter(i,raintexts[i].drawingIndices.Count - 1);
                        if (t != null)
                        {
                            t.Foreground = new SolidColorBrush(Colors.Lime);
                            t.Opacity = 0.7;
                        }
                        raintexts[i].drawingIndices.Add(Drawtext(character, Colors.White, raintexts[i].x, raintexts[i].y + 32 * raintexts[i].text_length));
                    }
                    else
                    {
                        TextBlock t = getDrawnCharacter(i, raintexts[i].drawingIndices.Count - 1);
                        if (t != null) t.Text = "" + character;
                    }
                }
                else
                {
                    if (raintexts[i].done_updating == false)
                    {
                        TextBlock t = getDrawnCharacter(i, raintexts[i].drawingIndices.Count - 1);
                        if (t != null) t.Foreground = new SolidColorBrush(Colors.Lime);                        
                        for (int j = raintexts[i].drawingIndices.Count - 1; j >= 0; j--)
                        {
                            if (cvsDraw.Children[raintexts[i].drawingIndices[j]].Opacity > 0.25)
                            {
                                cvsDraw.Children[raintexts[i].drawingIndices[j]].Opacity -= 0.02;
                            }
                            else
                                raintexts[i].done_updating = true;
                        }
                    }                    
                }
            }
        }
        //-----------------------------------------------------------------------------
        private void programm_end(object sender, MouseButtonEventArgs e)
        {
            this.Close();
        }
        //-----------------------------------------------------------------------------
        private TextBlock getDrawnCharacter(int rainstring, int index)
        {
            if (index >= 0)
            {
                int realIndex = raintexts[rainstring].drawingIndices[index];
                return (TextBlock)cvsDraw.Children[realIndex];
            }
            else return null;
        }
    }
}
